commit 9cb9623b850dbc100d1c4c25d5a9b853ceeabe22
Author: Alex <azirbel@andrew.cmu.edu>
Date:   Sat Dec 1 17:10:23 2012 -0500

    Working on turning sonar on and off for robots individually.

diff --git a/scout/scoutsim/src/scout.cpp b/scout/scoutsim/src/scout.cpp
index 9d9502f..58048f3 100644
--- a/scout/scoutsim/src/scout.cpp
+++ b/scout/scoutsim/src/scout.cpp
@@ -297,7 +297,7 @@ namespace scoutsim
                 // draw a circle at the wall_x, wall_y where reading > 128
                 sonar_dc.SelectObject(*path_bitmap);
                 sonar_dc.SetBrush(*wxRED_BRUSH); //old value
-                sonar_dc.DrawCircle(wxPoint(old_front_dx,old_front_dy), 2);
+                sonar_dc.DrawCircle(wxPoint(old_front_dx, old_front_dy), 2);
                 old_front_dx = d_x;
                 old_front_dy = d_y;
             }
diff --git a/scout/scoutsim/src/scoutsim.cpp b/scout/scoutsim/src/scoutsim.cpp
index 821558d..ed73040 100644
--- a/scout/scoutsim/src/scoutsim.cpp
+++ b/scout/scoutsim/src/scoutsim.cpp
@@ -138,6 +138,7 @@ BEGIN_EVENT_TABLE(scoutsim::SimFrame, wxFrame)
     EVT_MENU(ID_TELEOP_PRECISE, scoutsim::SimFrame::startTeleopPrecise)
     EVT_MENU(ID_TELEOP_FLUID, scoutsim::SimFrame::startTeleopFluid)
     EVT_MENU(ID_SONAR, scoutsim::SimFrame::showSonar)
+    EVT_MENU(ID_TEST, scoutsim::SimFrame::doTest)
 END_EVENT_TABLE()
 
 DECLARE_APP(ScoutApp);
diff --git a/scout/scoutsim/src/sim_frame.cpp b/scout/scoutsim/src/sim_frame.cpp
index 1b452c0..589f487 100644
--- a/scout/scoutsim/src/sim_frame.cpp
+++ b/scout/scoutsim/src/sim_frame.cpp
@@ -88,7 +88,7 @@ namespace scoutsim
         wxBitmap lines_bitmap;
         wxBitmap walls_bitmap;
         path_bitmap.LoadFile(wxString::FromAscii(display_map_name.c_str()));
-        sonar_visual_on = TRUE;
+        sonar_visual_on = true;
 
         // Try to load the file; if it fails, make a new blank file
         if (!lines_bitmap.LoadFile(wxString::FromAscii(map_lines_name.c_str())))
@@ -149,11 +149,15 @@ namespace scoutsim
         menuTeleop->Append(ID_TELEOP_PRECISE, _("&Precise"));
         menuTeleop->Append(ID_TELEOP_FLUID, _("&Fluid"));
 
+        wxMenu *menuTest = new wxMenu;
+        menuTest->Append(ID_TEST, _("&Scouts go here"));
+
         wxMenuBar *menuBar = new wxMenuBar;
         menuBar->Append(menuFile, _("&File"));
         menuBar->Append(menuSim, _("&Sim"));
         menuBar->Append(menuView, _("&View"));
         menuBar->Append(menuTeleop, _("&Teleop"));
+        menuBar->Append(menuTest, _("T&est"));
 
         SetMenuBar(menuBar);
 
@@ -279,9 +283,13 @@ namespace scoutsim
     void SimFrame::showSonar(wxCommandEvent& WXUNUSED(event))
     {
         sonar_visual_on = not sonar_visual_on;
-	clear();
+        clear();
     }
 
+    void SimFrame::doTest(wxCommandEvent& WXUNUSED(event))
+    {
+        clear();
+    }
 
     void SimFrame::showMap(wxCommandEvent& WXUNUSED(event))
     {
@@ -523,7 +531,7 @@ namespace scoutsim
         for (; it != end; ++it)
         {
             it->second->update(SCOUTSIM_REFRESH_RATE,
-                               path_dc,sonar_dc,sonar_visual_on,
+                               path_dc,sonar_dc, sonar_visual_on,
                                path_image, lines_image, walls_image,
                                path_dc.GetBackground().GetColour(),
                                sonar_dc.GetBackground().GetColour(),
diff --git a/scout/scoutsim/src/sim_frame.h b/scout/scoutsim/src/sim_frame.h
index 991a4d5..885f888 100644
--- a/scout/scoutsim/src/sim_frame.h
+++ b/scout/scoutsim/src/sim_frame.h
@@ -77,6 +77,7 @@
 #define ID_TELEOP_PRECISE 8
 #define ID_TELEOP_FLUID 9
 #define ID_SONAR 10
+#define ID_TEST 11
 
 // Absolute speeds (-128 - 127)
 #define TELEOP_PRECISE_SPEED 62
@@ -108,7 +109,8 @@ namespace scoutsim
             void stopTeleop(wxCommandEvent& event);
             void startTeleopPrecise(wxCommandEvent& event);
             void startTeleopFluid(wxCommandEvent& event);
-	    void showSonar(wxCommandEvent& event);
+            void showSonar(wxCommandEvent& event);
+            void doTest(wxCommandEvent& event);
 
             DECLARE_EVENT_TABLE()
 
@@ -174,7 +176,7 @@ namespace scoutsim
             float width_in_meters;
             float height_in_meters;
 
-	    bool sonar_visual_on;
+            bool sonar_visual_on;
 
             std::string map_base_name;
             std::string map_lines_name;