commit 20280a2e78d6756d70dbb54ca002ead89ce10b87
Author: Julian Binder <jabinder@andrew.cmu.edu>
Date:   Fri Nov 30 00:12:37 2012 -0500

    fixed error in confusion between SHDN and CLR. Also changed LED resistor values to 1K and also changed charge led to be 3.3V

diff --git a/scoutfly/scoutfly_rev3.brd b/scoutfly/scoutfly_rev3.brd
index 4969c6f..edd3c77 100755
--- a/scoutfly/scoutfly_rev3.brd
+++ b/scoutfly/scoutfly_rev3.brd
@@ -138,11 +138,7 @@
 <text x="4.826" y="74.93" size="1.016" layer="21" ratio="15" rot="R90">BATTERY</text>
 <text x="6.223" y="73.787" size="1.016" layer="21" ratio="15">-</text>
 <text x="8.763" y="73.787" size="1.016" layer="21" ratio="15">+</text>
-<text x="59.309" y="73.66" size="1.016" layer="21" ratio="15">+</text>
-<text x="61.849" y="73.66" size="1.016" layer="21" ratio="15">-</text>
-<text x="65.278" y="73.787" size="1.016" layer="21" ratio="15" rot="R90">CHARGE CONTACTS</text>
 <text x="69.469" y="73.914" size="1.016" layer="21" ratio="15" rot="R90">MOTORS / POWER</text>
-<text x="73.406" y="74.93" size="1.016" layer="21" ratio="15" rot="R180">SV1</text>
 <text x="86.36" y="84.709" size="1.016" layer="21" ratio="15" rot="R90">FFC</text>
 <text x="100.457" y="82.55" size="1.016" layer="21" ratio="15">J3</text>
 <text x="70.993" y="40.132" size="0.4064" layer="21" ratio="15">ARM_SPARE6</text>
@@ -170,12 +166,11 @@
 <text x="11.684" y="17.526" size="0.4064" layer="21" ratio="15">!IRQ</text>
 <text x="13.843" y="17.526" size="0.4064" layer="21" ratio="15">ARM GPIO</text>
 <text x="13.843" y="17.018" size="0.4064" layer="21" ratio="15">SPARE 8</text>
-<text x="13.97" y="24.003" size="0.4064" layer="21" ratio="15">SHDN</text>
+<text x="13.97" y="24.003" size="0.4064" layer="21" ratio="15">CLR</text>
 <text x="11.684" y="24.003" size="0.4064" layer="21" ratio="15">CS0</text>
 <text x="9.017" y="24.003" size="0.4064" layer="21" ratio="15">SCLK</text>
 <text x="6.477" y="24.003" size="0.4064" layer="21" ratio="15">MISO</text>
 <text x="4.064" y="24.003" size="0.4064" layer="21" ratio="15">GND</text>
-<text x="0.889" y="26.543" size="1.016" layer="21" ratio="15" rot="R270">SPI / ARM GPIO</text>
 <text x="103.124" y="53.594" size="1.016" layer="21" ratio="15">BOM3</text>
 <text x="103.124" y="40.894" size="1.016" layer="21" ratio="15">BOM2</text>
 <text x="103.124" y="28.194" size="1.016" layer="21" ratio="15">BOM1</text>
@@ -192,10 +187,11 @@
 <text x="109.601" y="0.381" size="0.762" layer="21" font="vector" ratio="15">GND</text>
 <text x="110.236" y="23.876" size="1.016" layer="22" ratio="15" rot="MR0">CLIFF 0</text>
 <text x="88.773" y="3.81" size="1.016" layer="21">USER 2</text>
-<text x="42.291" y="62.484" size="0.6096" layer="21" rot="R270">CHG</text>
+<text x="42.291" y="62.484" size="0.6096" layer="21" rot="R270">3.3V</text>
 <text x="44.831" y="2.032" size="1.27" layer="21" font="vector" ratio="15">tmullins yguo</text>
 <text x="44.958" y="0.508" size="1.27" layer="21" font="vector" ratio="15">bwasserm</text>
 <text x="62.865" y="3.81" size="1.27" layer="21" font="vector" ratio="15">kwoo</text>
+<text x="32.004" y="70.612" size="1.27" layer="21">PWR ON</text>
 </plain>
 <libraries>
 <library name="kwoo">
@@ -2108,8 +2104,8 @@ Please make sure your boards conform to these design rules.</description>
 </element>
 <element name="L5" library="kwoo" package="0805" value="MI0805K400R-10" x="36.123" y="12.549" rot="R270"/>
 <element name="Q3" library="kwoo" package="NX3225SA" value="16MHz" x="78.74" y="12.954" rot="MR0"/>
-<element name="R58" library="resistor" package="R0603" value="432" x="43.307" y="62.484" rot="MR270"/>
-<element name="R59" library="resistor" package="R0603" value="182" x="41.783" y="62.484" rot="MR270"/>
+<element name="R58" library="resistor" package="R0603" value="1k" x="43.307" y="62.484" rot="MR270"/>
+<element name="R59" library="resistor" package="R0603" value="1k" x="41.783" y="62.484" rot="MR270"/>
 <element name="F1" library="kwoo" package="SM200" value="" x="17.018" y="85.344"/>
 <element name="U$2" library="kwoo" package="24-SSOP" value="TB6612FNG" x="84.455" y="67.31" rot="R180"/>
 <element name="U$27" library="kwoo" package="24-SSOP" value="TB6612FNG" x="77.47" y="67.31" rot="MR180"/>
@@ -2138,7 +2134,7 @@ Please make sure your boards conform to these design rules.</description>
 <element name="R50" library="resistor" package="R0603" value="976" x="52.197" y="57.785" rot="MR90"/>
 <element name="R93" library="resistor" package="R0603" value="1.54K" x="41.783" y="56.007" rot="MR0"/>
 <element name="R94" library="resistor" package="R0603" value="1.54K" x="41.783" y="53.975" rot="MR0"/>
-<element name="R105" library="resistor" package="R0603" value="84.5" x="44.831" y="62.484" rot="MR270"/>
+<element name="R105" library="resistor" package="R0603" value="1k" x="44.831" y="62.484" rot="MR270"/>
 <element name="LED4" library="SparkFun" package="LED-0603" value="Blue" x="44.831" y="62.484" smashed="yes">
 <attribute name="VALUE" x="45.9105" y="61.468" size="0.4064" layer="27" rot="R90"/>
 </element>
@@ -2196,7 +2192,9 @@ Please make sure your boards conform to these design rules.</description>
 <element name="J3" library="kwoo" package="OMRON_XF" value="XF2L" x="94.488" y="85.471" smashed="yes" rot="R180">
 <attribute name="NAME" x="104.041" y="85.083" size="1.27" layer="25" font="vector" ratio="15" rot="SR90"/>
 </element>
-<element name="SV1" library="kwoo" package="MA06-2W" value="" x="78.74" y="77.47"/>
+<element name="SV1" library="kwoo" package="MA06-2W" value="" x="78.74" y="77.47" smashed="yes">
+<attribute name="VALUE" x="77.47" y="73.66" size="1.27" layer="27" ratio="10"/>
+</element>
 <element name="SV3" library="kwoo" package="MA02-2W" value="MA02-2W" x="7.874" y="81.026" smashed="yes">
 <attribute name="VALUE" x="4.699" y="71.501" size="1.27" layer="27" ratio="10"/>
 </element>
@@ -2927,15 +2925,10 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="39.497" y1="87.503" x2="41.148" y2="87.503" width="0.4064" layer="16"/>
 <wire x1="37.979" y1="87.503" x2="39.497" y2="87.503" width="0.4064" layer="1"/>
 <wire x1="36.449" y1="85.973" x2="37.979" y2="87.503" width="0.4064" layer="1"/>
-<wire x1="40.652" y1="63.234" x2="41.783" y2="63.234" width="0.4064" layer="1"/>
-<wire x1="40.513" y1="63.373" x2="40.652" y2="63.234" width="0.4064" layer="1"/>
 <wire x1="31.623" y1="63.881" x2="33.02" y2="65.278" width="0.4064" layer="1"/>
 <wire x1="31.623" y1="62.23" x2="31.623" y2="63.881" width="0.4064" layer="1"/>
 <wire x1="31.877" y1="61.976" x2="31.623" y2="62.23" width="0.4064" layer="1"/>
 <wire x1="31.877" y1="61.976" x2="32.95" y2="61.976" width="0.4064" layer="1"/>
-<wire x1="38.608" y1="61.087" x2="38.608" y2="56.769" width="0.4064" layer="16"/>
-<wire x1="38.608" y1="61.468" x2="38.608" y2="61.087" width="0.4064" layer="1"/>
-<wire x1="40.513" y1="63.373" x2="38.608" y2="61.468" width="0.4064" layer="1"/>
 <wire x1="31.877" y1="60.325" x2="31.877" y2="61.976" width="0.4064" layer="1"/>
 <wire x1="32.131" y1="60.071" x2="31.877" y2="60.325" width="0.4064" layer="1"/>
 <wire x1="33.401" y1="60.071" x2="32.131" y2="60.071" width="0.4064" layer="1"/>
@@ -2950,11 +2943,9 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="9.144" y1="60.325" x2="9.144" y2="64.008" width="0.4064" layer="1"/>
 <wire x1="9.525" y1="59.944" x2="9.144" y2="60.325" width="0.4064" layer="1"/>
 <wire x1="10.741" y1="59.944" x2="9.525" y2="59.944" width="0.4064" layer="1"/>
-<wire x1="10.741" y1="54.9116" x2="10.741" y2="58.674" width="0.4064" layer="1"/>
 <wire x1="10.741" y1="59.944" x2="10.741" y2="61.214" width="0.4064" layer="1"/>
 <wire x1="33.02" y1="65.278" x2="33.02" y2="65.786" width="0.4064" layer="1"/>
 <wire x1="33.02" y1="65.786" x2="38.1" y2="65.786" width="0.4064" layer="1"/>
-<wire x1="38.1" y1="65.786" x2="40.513" y2="63.373" width="0.4064" layer="1"/>
 <wire x1="23.622" y1="58.928" x2="23.241" y2="58.928" width="0.4064" layer="15"/>
 <wire x1="45.847" y1="88.011" x2="44.577" y2="86.741" width="0.4064" layer="16"/>
 <wire x1="46.609" y1="88.011" x2="45.847" y2="88.011" width="0.4064" layer="16"/>
@@ -3110,7 +3101,6 @@ Please make sure your boards conform to these design rules.</description>
 <via x="46.609" y="88.011" extent="1-16" drill="0.6"/>
 <via x="52.324" y="82.423" extent="1-16" drill="0.6"/>
 <via x="39.497" y="87.503" extent="1-16" drill="0.6"/>
-<via x="38.608" y="61.087" extent="1-16" drill="0.6"/>
 <via x="24.384" y="64.897" extent="1-16" drill="0.6"/>
 <polygon width="0.2032" layer="1" thermals="no">
 <vertex x="14.732" y="77.724"/>
@@ -3310,6 +3300,8 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="11.938" y1="40.679" x2="13.247" y2="39.37" width="0.2032" layer="16"/>
 <wire x1="15.494" y1="78.74" x2="15.494" y2="76.708" width="1.016" layer="1"/>
 <wire x1="15.494" y1="76.708" x2="14.351" y2="75.565" width="1.016" layer="1"/>
+<wire x1="41.783" y1="63.234" x2="40.652" y2="63.234" width="0.4064" layer="1"/>
+<wire x1="40.652" y1="63.234" x2="38.1" y2="65.786" width="0.4064" layer="1"/>
 </signal>
 <signal name="!PWR_KILL">
 <contactref element="U$16" pad="GPIO127_TS_IRQ"/>
@@ -3337,17 +3329,7 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="30.607" y1="47.498" x2="31.242" y2="46.863" width="0.2032" layer="16"/>
 <wire x1="30.607" y1="48.514" x2="30.607" y2="47.498" width="0.2032" layer="16"/>
 <wire x1="30.861" y1="48.768" x2="30.607" y2="48.514" width="0.2032" layer="16"/>
-<wire x1="33.909" y1="48.768" x2="30.861" y2="48.768" width="0.2032" layer="16"/>
-<wire x1="34.163" y1="49.022" x2="33.909" y2="48.768" width="0.2032" layer="16"/>
-<wire x1="34.163" y1="53.467" x2="34.163" y2="49.022" width="0.2032" layer="16"/>
-<wire x1="13.843" y1="46.482" x2="16.51" y2="43.815" width="0.4064" layer="1"/>
-<wire x1="16.51" y1="43.815" x2="25.908" y2="43.815" width="0.4064" layer="1"/>
-<wire x1="25.908" y1="43.815" x2="30.099" y2="48.006" width="0.4064" layer="1"/>
-<wire x1="30.099" y1="48.006" x2="30.099" y2="51.054" width="0.4064" layer="1"/>
-<wire x1="30.099" y1="51.054" x2="32.512" y2="53.467" width="0.4064" layer="1"/>
-<wire x1="32.512" y1="53.467" x2="34.163" y2="53.467" width="0.4064" layer="1"/>
 <via x="34.544" y="37.084" extent="1-16" drill="0.381"/>
-<via x="34.163" y="53.467" extent="1-16" drill="0.381"/>
 </signal>
 <signal name="+5V">
 <contactref element="U$35" pad="6"/>
@@ -3729,16 +3711,13 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="18.796" y1="30.099" x2="18.796" y2="32.258" width="0.2032" layer="1"/>
 <wire x1="18.796" y1="32.258" x2="18.542" y2="32.512" width="0.2032" layer="1"/>
 <wire x1="18.542" y1="32.512" x2="16.764" y2="32.512" width="0.2032" layer="1"/>
-<wire x1="47.752" y1="58.166" x2="47.498" y2="58.42" width="0.254" layer="1"/>
 <wire x1="50.8" y1="48.895" x2="50.8" y2="50.546" width="0.254" layer="1"/>
 <wire x1="50.8" y1="50.546" x2="50.546" y2="50.8" width="0.254" layer="1"/>
 <wire x1="50.546" y1="50.8" x2="47.713" y2="50.8" width="0.254" layer="1"/>
 <wire x1="47.713" y1="50.8" x2="47.713" y2="52.197" width="0.254" layer="1"/>
-<wire x1="47.752" y1="52.236" x2="47.752" y2="55.499" width="0.254" layer="1"/>
-<wire x1="47.752" y1="55.499" x2="47.752" y2="58.166" width="0.254" layer="1"/>
+<wire x1="47.752" y1="52.236" x2="47.752" y2="55.062" width="0.254" layer="1"/>
 <wire x1="47.713" y1="52.197" x2="47.752" y2="52.236" width="0.254" layer="1"/>
 <wire x1="47.752" y1="55.062" x2="44.7" y2="55.062" width="0.254" layer="1"/>
-<wire x1="47.752" y1="55.499" x2="47.752" y2="55.062" width="0.254" layer="1"/>
 <via x="63.246" y="46.101" extent="1-16" drill="0.381"/>
 <via x="61.722" y="44.577" extent="1-16" drill="0.381"/>
 <via x="66.802" y="39.243" extent="1-16" drill="0.381"/>
@@ -3784,9 +3763,6 @@ Please make sure your boards conform to these design rules.</description>
 <vertex x="31.75" y="75.565"/>
 </polygon>
 </signal>
-<signal name="VCHARGE">
-<contactref element="R58" pad="1"/>
-</signal>
 <signal name="VUSB">
 <contactref element="L5" pad="1"/>
 <contactref element="U$16" pad="USBOTG_VBUS"/>
@@ -5381,8 +5357,6 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="100.623" y1="59.348" x2="100.711" y2="59.436" width="0.254" layer="1"/>
 <wire x1="100.711" y1="59.436" x2="102.401" y2="59.436" width="0.254" layer="1"/>
 <wire x1="52.197" y1="58.635" x2="53.467" y2="58.635" width="0.254" layer="16"/>
-<wire x1="49.569" y1="58.635" x2="50.927" y2="58.635" width="0.254" layer="16"/>
-<wire x1="49.53" y1="58.674" x2="49.569" y2="58.635" width="0.254" layer="16"/>
 <wire x1="103.632" y1="26.543" x2="105.068" y2="26.543" width="0.254" layer="16"/>
 <wire x1="100.65" y1="12.192" x2="99.695" y2="12.192" width="0.254" layer="1"/>
 <wire x1="99.695" y1="12.192" x2="99.568" y2="12.065" width="0.254" layer="1"/>
@@ -5502,10 +5476,6 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="24.13" y1="48.641" x2="24.892" y2="47.879" width="1.016" layer="1"/>
 <wire x1="24.892" y1="47.879" x2="24.13" y2="47.879" width="1.016" layer="1"/>
 <wire x1="24.13" y1="47.879" x2="23.876" y2="47.625" width="1.016" layer="1"/>
-<wire x1="8.763" y1="43.815" x2="8.763" y2="41.402" width="0.4064" layer="1"/>
-<wire x1="8.509" y1="44.069" x2="8.763" y2="43.815" width="0.4064" layer="1"/>
-<wire x1="3.683" y1="44.069" x2="8.509" y2="44.069" width="0.4064" layer="1"/>
-<wire x1="3.683" y1="44.069" x2="3.683" y2="46.3804" width="0.4064" layer="1"/>
 <wire x1="13.716" y1="61.214" x2="23.241" y2="61.214" width="0.4064" layer="16"/>
 <wire x1="23.241" y1="61.214" x2="23.749" y2="60.706" width="0.4064" layer="16"/>
 <wire x1="14.263" y1="58.586" x2="14.263" y2="60.667" width="0.4064" layer="16"/>
@@ -5539,7 +5509,6 @@ Please make sure your boards conform to these design rules.</description>
 <via x="100.711" y="21.463" extent="1-16" drill="0.381"/>
 <via x="96.901" y="17.272" extent="1-16" drill="0.381"/>
 <via x="56.388" y="58.674" extent="1-16" drill="0.381"/>
-<via x="49.53" y="58.674" extent="1-16" drill="0.381"/>
 <via x="107.696" y="16.51" extent="1-16" drill="0.381"/>
 <via x="103.632" y="26.543" extent="1-16" drill="0.381"/>
 <via x="99.568" y="11.049" extent="1-16" drill="0.381"/>
@@ -5624,6 +5593,15 @@ Please make sure your boards conform to these design rules.</description>
 <vertex x="0.762" y="49.276"/>
 <vertex x="20.066" y="49.276"/>
 </polygon>
+<contactref element="R58" pad="1"/>
+<wire x1="43.307" y1="63.334" x2="43.307" y2="64.77" width="0.2032" layer="16"/>
+<wire x1="43.307" y1="64.77" x2="44.196" y2="65.659" width="0.2032" layer="16"/>
+<wire x1="44.196" y1="65.659" x2="46.863" y2="65.659" width="0.2032" layer="16"/>
+<wire x1="46.863" y1="65.659" x2="48.641" y2="63.881" width="0.2032" layer="16"/>
+<wire x1="48.641" y1="63.881" x2="50.165" y2="63.881" width="0.2032" layer="16"/>
+<wire x1="50.165" y1="63.881" x2="51.054" y2="62.992" width="0.2032" layer="16"/>
+<wire x1="51.054" y1="62.992" x2="51.054" y2="58.762" width="0.2032" layer="16"/>
+<wire x1="51.054" y1="58.762" x2="50.927" y2="58.635" width="0.2032" layer="16"/>
 </signal>
 <signal name="DEBUG_TX_1.8V">
 <contactref element="U$16" pad="GPIO166_IR_TXD3"/>
@@ -8697,27 +8675,6 @@ Please make sure your boards conform to these design rules.</description>
 <via x="27.559" y="76.708" extent="1-16" drill="0.6"/>
 <via x="15.367" y="56.134" extent="1-16" drill="0.6"/>
 <via x="20.828" y="63.754" extent="1-16" drill="0.6"/>
-<contactref element="U10" pad="13"/>
-<contactref element="JP4" pad="2"/>
-<wire x1="19.812" y1="24.13" x2="19.939" y2="24.257" width="0.2032" layer="1"/>
-<wire x1="15.113" y1="24.13" x2="19.812" y2="24.13" width="0.2032" layer="1"/>
-<wire x1="14.732" y1="23.749" x2="15.113" y2="24.13" width="0.2032" layer="1"/>
-<wire x1="14.732" y1="22.225" x2="14.732" y2="23.749" width="0.2032" layer="1"/>
-<wire x1="19.939" y1="24.257" x2="19.939" y2="26.543" width="0.2032" layer="1"/>
-<wire x1="19.939" y1="26.543" x2="20.32" y2="26.924" width="0.2032" layer="1"/>
-<wire x1="20.32" y1="26.924" x2="20.32" y2="27.94" width="0.2032" layer="1"/>
-<wire x1="20.981" y1="28.601" x2="22.477" y2="28.601" width="0.2032" layer="1"/>
-<wire x1="20.32" y1="27.94" x2="20.981" y2="28.601" width="0.2032" layer="1"/>
-<wire x1="9.271" y1="56.134" x2="6.858" y2="53.721" width="0.2032" layer="16"/>
-<wire x1="6.858" y1="53.721" x2="6.096" y2="53.721" width="0.2032" layer="16"/>
-<wire x1="6.096" y1="53.721" x2="0.762" y2="48.387" width="0.2032" layer="16"/>
-<wire x1="0.762" y1="48.387" x2="0.762" y2="24.13" width="0.2032" layer="16"/>
-<wire x1="0.762" y1="24.13" x2="1.27" y2="23.622" width="0.2032" layer="16"/>
-<wire x1="1.27" y1="23.622" x2="3.302" y2="23.622" width="0.2032" layer="16"/>
-<wire x1="3.302" y1="23.622" x2="3.683" y2="24.003" width="0.2032" layer="16"/>
-<wire x1="3.683" y1="24.003" x2="14.478" y2="24.003" width="0.2032" layer="16"/>
-<wire x1="14.478" y1="24.003" x2="14.732" y2="23.749" width="0.2032" layer="16"/>
-<wire x1="14.732" y1="23.749" x2="14.732" y2="22.225" width="0.2032" layer="16"/>
 </signal>
 <signal name="ARM_SHDN">
 <contactref element="U10" pad="8"/>
@@ -8752,6 +8709,33 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="18.669" y1="39.116" x2="18.669" y2="40.005" width="0.2032" layer="16"/>
 <wire x1="18.669" y1="40.005" x2="18.542" y2="40.132" width="0.2032" layer="16"/>
 </signal>
+<signal name="CLR">
+<contactref element="U$9" pad="3"/>
+<contactref element="U10" pad="13"/>
+<contactref element="JP4" pad="2"/>
+<wire x1="22.477" y1="28.601" x2="20.981" y2="28.601" width="0.2032" layer="1"/>
+<wire x1="20.981" y1="28.601" x2="20.32" y2="27.94" width="0.2032" layer="1"/>
+<wire x1="20.32" y1="27.94" x2="20.32" y2="26.924" width="0.2032" layer="1"/>
+<wire x1="20.32" y1="26.924" x2="19.939" y2="26.543" width="0.2032" layer="1"/>
+<wire x1="19.939" y1="26.543" x2="19.939" y2="24.384" width="0.2032" layer="1"/>
+<wire x1="19.939" y1="24.384" x2="19.685" y2="24.13" width="0.2032" layer="1"/>
+<wire x1="19.685" y1="24.13" x2="15.748" y2="24.13" width="0.2032" layer="1"/>
+<wire x1="15.748" y1="24.13" x2="14.732" y2="23.114" width="0.2032" layer="1"/>
+<wire x1="14.732" y1="23.114" x2="14.732" y2="22.225" width="0.2032" layer="1"/>
+<wire x1="32.7" y1="56.348" x2="32.7" y2="55.052" width="0.2032" layer="1"/>
+<wire x1="32.7" y1="55.052" x2="28.194" y2="50.546" width="0.2032" layer="1"/>
+<wire x1="28.194" y1="50.546" x2="28.194" y2="45.72" width="0.2032" layer="1"/>
+<wire x1="28.194" y1="45.72" x2="25.4" y2="42.926" width="0.2032" layer="1"/>
+<wire x1="25.4" y1="42.926" x2="2.54" y2="42.926" width="0.2032" layer="1"/>
+<wire x1="2.54" y1="42.926" x2="1.27" y2="41.656" width="0.2032" layer="1"/>
+<wire x1="1.27" y1="41.656" x2="1.27" y2="22.86" width="0.2032" layer="1"/>
+<wire x1="1.27" y1="22.86" x2="1.397" y2="22.733" width="0.2032" layer="1"/>
+<via x="1.397" y="22.733" extent="1-16" drill="0.381"/>
+<wire x1="1.397" y1="22.733" x2="1.905" y2="22.733" width="0.2032" layer="16"/>
+<wire x1="1.905" y1="22.733" x2="2.921" y2="23.749" width="0.2032" layer="16"/>
+<wire x1="2.921" y1="23.749" x2="13.208" y2="23.749" width="0.2032" layer="16"/>
+<wire x1="13.208" y1="23.749" x2="14.732" y2="22.225" width="0.2032" layer="16"/>
+</signal>
 </signals>
 </board>
 </drawing>