commit 20280a2e78d6756d70dbb54ca002ead89ce10b87
Author: Julian Binder <jabinder@andrew.cmu.edu>
Date:   Fri Nov 30 00:12:37 2012 -0500

    fixed error in confusion between SHDN and CLR. Also changed LED resistor values to 1K and also changed charge led to be 3.3V

diff --git a/scoutfly/scoutfly_rev3.sch b/scoutfly/scoutfly_rev3.sch
index 0ac3f0a..c6ae180 100755
--- a/scoutfly/scoutfly_rev3.sch
+++ b/scoutfly/scoutfly_rev3.sch
@@ -2783,12 +2783,6 @@ Source: http://www.hirose.co.jp/cataloge_hp/e24000019.pdf</description>
 <text x="-2.54" y="-2.54" size="1.778" layer="96" rot="R90">&gt;VALUE</text>
 <pin name="VBATT" x="0" y="0" visible="off" length="short" direction="sup" rot="R90"/>
 </symbol>
-<symbol name="VCHARGE">
-<wire x1="1.27" y1="0.635" x2="0" y2="2.54" width="0.254" layer="94"/>
-<wire x1="0" y1="2.54" x2="-1.27" y2="0.635" width="0.254" layer="94"/>
-<text x="-2.54" y="-2.54" size="1.778" layer="96" rot="R90">&gt;VALUE</text>
-<pin name="VCHARGE" x="0" y="0" visible="off" length="short" direction="sup" rot="R90"/>
-</symbol>
 <symbol name="VUSB">
 <wire x1="1.27" y1="0.635" x2="0" y2="2.54" width="0.254" layer="94"/>
 <wire x1="0" y1="2.54" x2="-1.27" y2="0.635" width="0.254" layer="94"/>
@@ -2847,18 +2841,6 @@ Source: http://www.hirose.co.jp/cataloge_hp/e24000019.pdf</description>
 </device>
 </devices>
 </deviceset>
-<deviceset name="VCHARGE" prefix="VCHARGE">
-<gates>
-<gate name="G$1" symbol="VCHARGE" x="-7.62" y="2.54"/>
-</gates>
-<devices>
-<device name="">
-<technologies>
-<technology name=""/>
-</technologies>
-</device>
-</devices>
-</deviceset>
 <deviceset name="VUSB" prefix="VUSB">
 <gates>
 <gate name="G$1" symbol="VUSB" x="-5.08" y="-2.54"/>
@@ -19022,11 +19004,10 @@ Source: 3967.pdf</description>
 <part name="Q3" library="kwoo" deviceset="NX3225SA" device="" value="16MHz"/>
 <part name="GND33" library="supply1" deviceset="GND" device=""/>
 <part name="P+3" library="supply1" deviceset="+5V" device=""/>
-<part name="VCHARGE2" library="supply1" deviceset="VCHARGE" device=""/>
 <part name="VBATT3" library="supply1" deviceset="VBATT" device=""/>
 <part name="GND35" library="supply1" deviceset="GND" device=""/>
-<part name="R58" library="resistor" deviceset="R-US_" device="R0603" value="432"/>
-<part name="R59" library="resistor" deviceset="R-US_" device="R0603" value="182"/>
+<part name="R58" library="resistor" deviceset="R-US_" device="R0603" value="1k"/>
+<part name="R59" library="resistor" deviceset="R-US_" device="R0603" value="1k"/>
 <part name="F1" library="kwoo" deviceset="MF-SM200" device=""/>
 <part name="U$2" library="kwoo" deviceset="TB6612FNG" device=""/>
 <part name="U$27" library="kwoo" deviceset="TB6612FNG" device=""/>
@@ -19061,7 +19042,7 @@ Source: 3967.pdf</description>
 <part name="R94" library="resistor" deviceset="R-US_" device="R0603" value="1.54K"/>
 <part name="GND68" library="supply1" deviceset="GND" device=""/>
 <part name="GND69" library="supply1" deviceset="GND" device=""/>
-<part name="R105" library="resistor" deviceset="R-US_" device="R0603" value="84.5"/>
+<part name="R105" library="resistor" deviceset="R-US_" device="R0603" value="1k"/>
 <part name="LED4" library="SparkFun" deviceset="LED" device="0603" value="Blue"/>
 <part name="LED6" library="SparkFun" deviceset="LED" device="0603" value="Blue"/>
 <part name="LED7" library="SparkFun" deviceset="LED" device="0603" value="Blue"/>
@@ -19379,6 +19360,7 @@ Source: 3967.pdf</description>
 <part name="GND18" library="supply1" deviceset="GND" device=""/>
 <part name="P+12" library="supply1" deviceset="VCC" device=""/>
 <part name="GND15" library="supply1" deviceset="GND" device=""/>
+<part name="+3V33" library="supply1" deviceset="+3V3" device=""/>
 </parts>
 <sheets>
 <sheet>
@@ -19431,7 +19413,6 @@ Source: 3967.pdf</description>
 <instance part="Q3" gate="G$1" x="322.58" y="-86.36"/>
 <instance part="GND33" gate="1" x="327.66" y="-101.6"/>
 <instance part="P+3" gate="1" x="-485.14" y="175.26"/>
-<instance part="VCHARGE2" gate="G$1" x="-464.82" y="172.72"/>
 <instance part="VBATT3" gate="G$1" x="-474.98" y="172.72"/>
 <instance part="GND35" gate="1" x="-485.14" y="124.46" rot="MR0"/>
 <instance part="R58" gate="G$1" x="-464.82" y="162.56" rot="R270"/>
@@ -19851,6 +19832,7 @@ Source: 3967.pdf</description>
 <instance part="GND18" gate="1" x="-541.02" y="40.64" rot="MR0"/>
 <instance part="P+12" gate="VCC" x="-510.54" y="106.68"/>
 <instance part="GND15" gate="1" x="81.28" y="-195.58"/>
+<instance part="+3V33" gate="G$1" x="-464.82" y="175.26"/>
 </instances>
 <busses>
 </busses>
@@ -20758,13 +20740,6 @@ Source: 3967.pdf</description>
 <pinref part="R59" gate="G$1" pin="1"/>
 </segment>
 </net>
-<net name="VCHARGE" class="0">
-<segment>
-<wire x1="-464.82" y1="172.72" x2="-464.82" y2="167.64" width="0.1524" layer="91"/>
-<pinref part="VCHARGE2" gate="G$1" pin="VCHARGE"/>
-<pinref part="R58" gate="G$1" pin="1"/>
-</segment>
-</net>
 <net name="VUSB" class="0">
 <segment>
 <wire x1="530.86" y1="-261.62" x2="525.78" y2="-261.62" width="0.1524" layer="91"/>
@@ -22116,6 +22091,11 @@ Source: 3967.pdf</description>
 <pinref part="+3V9" gate="G$1" pin="+3V3"/>
 <pinref part="C23" gate="G$1" pin="+"/>
 </segment>
+<segment>
+<wire x1="-464.82" y1="172.72" x2="-464.82" y2="167.64" width="0.1524" layer="91"/>
+<pinref part="R58" gate="G$1" pin="1"/>
+<pinref part="+3V33" gate="G$1" pin="+3V3"/>
+</segment>
 </net>
 <net name="DEBUG_TX_1.8V" class="0">
 <segment>
@@ -24031,16 +24011,6 @@ Source: 3967.pdf</description>
 <label x="-360.68" y="124.46" size="1.778" layer="95"/>
 <pinref part="U$10" gate="G$1" pin="SHDN"/>
 </segment>
-<segment>
-<wire x1="93.98" y1="-147.32" x2="93.98" y2="-127" width="0.1524" layer="91"/>
-<label x="93.98" y="-142.24" size="1.778" layer="95" rot="R90"/>
-<pinref part="U10" gate="G$7" pin="B"/>
-</segment>
-<segment>
-<wire x1="162.56" y1="-175.26" x2="182.88" y2="-175.26" width="0.1524" layer="91"/>
-<label x="165.1" y="-175.26" size="1.778" layer="95"/>
-<pinref part="JP4" gate="G$1" pin="2"/>
-</segment>
 </net>
 <net name="ARM_SHDN" class="0">
 <segment>
@@ -24055,6 +24025,23 @@ Source: 3967.pdf</description>
 <pinref part="U$16" gate="G$1" pin="GPIO68_L_FCLK"/>
 </segment>
 </net>
+<net name="CLR" class="0">
+<segment>
+<pinref part="U$9" gate="G$1" pin="CLEAR"/>
+<wire x1="-447.04" y1="22.86" x2="-472.44" y2="22.86" width="0.1524" layer="91"/>
+<label x="-469.9" y="22.86" size="1.778" layer="95"/>
+</segment>
+<segment>
+<pinref part="U10" gate="G$7" pin="B"/>
+<wire x1="93.98" y1="-147.32" x2="93.98" y2="-127" width="0.1524" layer="91"/>
+<label x="93.98" y="-139.7" size="1.778" layer="95" rot="R90"/>
+</segment>
+<segment>
+<pinref part="JP4" gate="G$1" pin="2"/>
+<wire x1="162.56" y1="-175.26" x2="182.88" y2="-175.26" width="0.1524" layer="91"/>
+<label x="165.1" y="-175.26" size="1.778" layer="95"/>
+</segment>
+</net>
 </nets>
 </sheet>
 </sheets>